/* This Software Created by Muhammad Arshad Latti from Sargodha (Pakistan)
E-Mail :: arshadlatti@gmail.com 
Web Page :: http://www.geocities.com/arshadlati
You can download complied and source versions at  http://www.geocities.com/arshadlati/Projects.htm */

#include "CopyFilePart.h"  

HINSTANCE g_hInstance;
HICON g_icoCfp;
BOOL g_bCancel=FALSE;

// resource copying animate avi in shell32.dll used in copying dialog.
HMODULE hShell32=LoadLibrary("Shell32.dll");

// entry point 
int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	// save instance handle for later use.
	g_hInstance=hInstance;

	// load icon for main dialog and about dialog
	g_icoCfp=LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CFP) );

	// used for Windows XP themes (Styles) support and progress bar class.
	InitCommonControls();

	// display main dialog window.
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), 0, (DLGPROC)DlgProc);

	// clean up stuff.
	DestroyIcon(g_icoCfp);
	return 0;
}

// main dialog box procedure.
LRESULT CALLBACK DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{

	case WM_INITDIALOG:
		{	
			CheckDlgButton(hwndDlg,IDC_CHK_SHOW,BST_CHECKED);// check Show Progress check box.
			// set dialog icon. 
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_icoCfp);
			return true;
		}
	case WM_COMMAND:
		{
			switch( wParam ) 
			{
			case IDC_BTN_SOURCE:// source file path selection button clicked.
				GetFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_TXT_SOURCE),TRUE);
				break;
			case IDC_BTN_OUTPUT:// output file path selection button clicked.
				GetFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_TXT_OUT),FALSE);
				break;
			case IDC_BTN_ABOUT:// about button clicked.
				DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_ABOUT),hwndDlg,(DLGPROC)AboutDlgProc);
				break;
			case IDC_BTN_COPY:// copy button clicked.
				Copy(hwndDlg);
				break;
			}
			break;
		}

	case WM_CLOSE:// close button clicked on title bar.
		{
			EndDialog(hwndDlg,0);
			break;
		}


	}
	return FALSE;
}
// copying dialog box procedure.
// copying dialog box show progress and user can cancel copying.
// note :: copying dialog only showed when show progress check box is checked.
LRESULT CALLBACK CopyingDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
CfpEx * pPram;
DWORD dwThreadID;
HANDLE hThread;

	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam==IDC_BTN_CANCEL)// cancel button clicked.
			g_bCancel=TRUE;// cancel copying process by setting flag value to true. 
		break;
	case WM_INITDIALOG:
			pPram=(CfpEx *)lParam;	
			pPram->hwnd=hwndDlg;
			g_bCancel=FALSE;

			// open copying avi from shell32.dll.
			Animate_OpenEx(GetDlgItem(hwndDlg,IDC_AVI_COPY),hShell32,MAKEINTRESOURCE(161));
			
			// start copying process by creating a new thread for CopyPartEx function.
			// CopyPartEx will control copying dialog box and progress bar.
			hThread=CreateThread(NULL, 0,
			(LPTHREAD_START_ROUTINE) CopyPartEx,
			pPram, 0, &dwThreadID);
			return true;
	case WM_CLOSE:// close button clicked on title bar.
			g_bCancel=TRUE;// cancel copying process by setting flag value to true. 
			break;	
	}
	return FALSE;
}

// about dialog messages.
LRESULT CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam==IDC_BTN_OK)// ok button clicked on about dialog box.
			EndDialog(hwndDlg,0);// close the about dialog box.
		break;
	case WM_INITDIALOG:
		{	
			// set about dialog icon. 
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_icoCfp);
			return true;
		}
	case WM_CLOSE:
		{
			EndDialog(hwndDlg,0);
			break;
		}	
	}
	return FALSE;
}

// get source and output file name/path.
void GetFilePath(HWND hwnd,HWND hTextBox,BOOL bOpen)
{
	OPENFILENAME ofn;
	char szFile[BUF_SIZE],szBuf[BUF_SIZE];



	ZeroMemory(&ofn, sizeof(ofn));
	szFile[0]=0;

	ofn.lpstrFile = szFile;
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd;// parent window handle. 
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrFilter ="All Files\0*.*\0\0";// any file type as source or output.

	if (bOpen==TRUE)// select a source file path/name. 
	{
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_HIDEREADONLY;
		ofn.lpstrTitle="Open...";

		if (GetOpenFileName(&ofn)==TRUE)
		{
			// set text of source file path text box to selected file.
			SetWindowText(hTextBox,szFile);
			// set text of start byte position to 1. 
			SetDlgItemText(hwnd,IDC_TXT_START,"1");
			// get size of selected file and set text of "length" text box.
			wsprintf(szBuf,"%lu",GetFileSize(szFile));
			SetDlgItemText(hwnd,IDC_TXT_LEN,szBuf);
		}
	}
	else// select output file name/path.
	{
		if (GetDlgItemText(hwnd,IDC_TXT_SOURCE,szBuf,MAX_PATH) > 0)
		{
			// try to find file name from "source file path" text box and set it to "save as" dialog.
			wsprintf(szFile,"%s",PathFindFileName(szBuf));
			ofn.lpstrFile = szFile;
		}
		ofn.Flags = OFN_NODEREFERENCELINKS;
		ofn.lpstrTitle="Save As...";

		if (GetSaveFileName(&ofn)==TRUE)
			SetWindowText(hTextBox,szFile);
	}
}

// start the copying process.
void Copy(HWND hWndDlg)
{
	CHAR pszSourceFileName[BUF_SIZE];
	CHAR pszOutputFileName[BUF_SIZE];
	CHAR pszStartByte[BUF_SIZE];
	CHAR pszLength[BUF_SIZE];
	LONG lStart;
	DWORD dwLength,dwStart,dwSourceFileSize;

	// check for source file path.
	if (GetDlgItemText(hWndDlg,IDC_TXT_SOURCE,pszSourceFileName,BUF_SIZE) < 1)
	{
		ErrMsg(hWndDlg,"Please select a source file name.");
		return;
	}
	// check if source file exists.
	if (PathFileExists(pszSourceFileName)==FALSE)
			{
		ErrMsg(hWndDlg,"Source file name is not valid.");
		return;
			}
	// check for file size if size is zero then show error message.
	if (GetFileSize(pszSourceFileName) < 1)
	{
		ErrMsg(hWndDlg,"Source file size is not valid.");
		return;
	}
	// check for output file path.
	if (GetDlgItemText(hWndDlg,IDC_TXT_OUT,pszOutputFileName,BUF_SIZE) < 1)
	{
		ErrMsg(hWndDlg,"Please select a output file name.");
		return;
	}
	// check for "start byte position".
	if (GetDlgItemText(hWndDlg,IDC_TXT_START,pszStartByte,BUF_SIZE) < 1)
	{
		ErrMsg(hWndDlg,"Please enter start byte Position.");
		return;
	}
	// check for "length(in bytes)".
	if (GetDlgItemText(hWndDlg,IDC_TXT_LEN,pszLength,BUF_SIZE) < 1)
	{
		ErrMsg(hWndDlg,"Please enter length in bytes.");
		return;
	}

	lStart=atol(pszStartByte);// convert "start byte position" string into LONG.
	dwStart=strtoul(pszStartByte, NULL, 0);// convert "start byte position" string into DWORD.
	dwLength=strtoul(pszLength, NULL, 0);// convert "length in bytes" string into DWORD.

	lStart-=1;

	dwSourceFileSize=GetFileSize(pszSourceFileName);// get source file size.
    
	// check if "start byte position" is less then one or greater then file size.
	if (dwStart < 1 || dwStart >dwSourceFileSize)
	{
		ErrMsg(hWndDlg,"Please enter a correct value in start byte position.");
		return;
	}

	dwSourceFileSize+=1;

	// check if "length in bytes" is less then one or greater then file size from "start byte position".
	if ( dwLength < 1 || dwLength + dwStart > dwSourceFileSize)
	{
		ErrMsg(hWndDlg,"Please enter a correct value in Length.");
		return;
	}
	// basic checking is over now call CopyFilePart.
	CopyFilePart(hWndDlg,pszSourceFileName,pszOutputFileName,lStart,dwLength);


}

// show error message.
void ErrMsg(HWND hwnd,LPSTR lpMsg)
{
MessageBox(hwnd,lpMsg ,"Error",MB_OK |MB_ICONSTOP);
}

// get a file size.
DWORD GetFileSize(LPSTR szFilePath)
{
	DWORD dwFileSize;
	HANDLE hCf;

	// try to open file.
	hCf = CreateFile(szFilePath,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);

	// check if file is opened.
	if (hCf==INVALID_HANDLE_VALUE)
		return (NULL);// file not open return null.

	dwFileSize=GetFileSize(hCf,NULL);// try to get file size.
	CloseHandle(hCf);// close file.
	
	// check for invalid file size.
	if (dwFileSize==INVALID_FILE_SIZE && GetLastError()!=NO_ERROR)
		return (NULL);// file size is invalid return null.
	
	return (dwFileSize);// return file size.
}

// open files for copying file part operation. 
BOOL CopyFilePart(HWND hWnd,LPSTR lpSourceFileName,LPSTR lpOutputFileName,LONG lStartByte,DWORD dwLength)
{
	HANDLE hSourceFile,hOutputFile;
	CfpEx CfPram;

	// try to create new output file.
	hOutputFile = CreateFile(lpOutputFileName,
		GENERIC_WRITE,FILE_SHARE_READ,NULL,
		CREATE_NEW,FILE_ATTRIBUTE_NORMAL,
		NULL);
	
	if (hOutputFile==INVALID_HANDLE_VALUE)// check if file created.
	{
		ErrMsg(hWnd,"Error while creating new output file.");
		return(FALSE);
	}

	// try to open source file.
	hSourceFile = CreateFile(lpSourceFileName,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);

	if (hSourceFile==INVALID_HANDLE_VALUE)// check if file opened.
	{
		ErrMsg(hWnd,"Error while opening Source(input) file.");
		CloseHandle(hOutputFile);
		return(FALSE);
	}

	// if "show progress" check box is checked then show copying dialog box
	// else simply copy file part without progress dialog. 
	if(IsDlgButtonChecked(hWnd,IDC_CHK_SHOW)==BST_CHECKED)
	{
		// fill out lParam parameter of the WM_INITDIALOG message for copying dialog box.
		CfPram.hSourceFile=hSourceFile;
		CfPram.hOutputFile=hOutputFile;
		CfPram.lStartByte=lStartByte;
		CfPram.dwLength=dwLength;

		// show copying dialog box.
		DialogBoxParam(g_hInstance,MAKEINTRESOURCE(IDD_COPYING), 
			hWnd, (DLGPROC)CopyingDlgProc, (LPARAM)&CfPram);
	}
	else// simply copy file part.
	{
	CopyPart(hSourceFile,hOutputFile,lStartByte,dwLength);
	}

	// close source(input) and destination(output) files.
	CloseHandle(hOutputFile);
	CloseHandle(hSourceFile);
	return(TRUE);
}
// copy file part without progress dialog box and cancel option.
void CopyPart(HANDLE hfSource,HANDLE hfOutput,LONG lStartByte,DWORD dwLength)
{
	DWORD dwRemaining,dwRead,dwWrite;
	CHAR * pBuffer[CFP_BUFFER_SIZE];
	BOOL bSuccess; 

	// seek to start byte position.
	SetFilePointer(hfSource,lStartByte,NULL,FILE_BEGIN);
	dwRemaining=dwLength;

	do
	{
		bSuccess=ReadFile(hfSource,pBuffer,CFP_BUFFER_SIZE,&dwRead,NULL);

		if(dwRemaining > dwRead)
		{
			WriteFile(hfOutput,pBuffer,dwRead,&dwWrite,0);
			dwRemaining -=dwRead;
		}
		else if (dwRead >= dwRemaining)
		{
			WriteFile(hfOutput,pBuffer,dwRemaining,&dwWrite,0);
			dwRemaining=0;
		}

	} while (dwRead > 0 && dwRemaining > 0 && bSuccess);

}

// copy file part with progress dialog box and cancel option.
void CopyPartEx(CfpEx * pPram)
{
	DWORD dwRemaining,dwRead,dwWrite,dwWritten;
	CHAR * pBuffer[CFP_BUFFER_SIZE];
	BOOL bSuccess;

	dwWrite=0;
	dwWritten=0;

	// get progress bar window handle.
	HWND hPb=GetDlgItem(pPram->hwnd,IDC_PROGRESS_BAR);


	// seek to start byte position.
	SetFilePointer(pPram->hSourceFile,pPram->lStartByte,NULL,FILE_BEGIN);
	dwRemaining=pPram->dwLength;

	do
	{
		bSuccess=ReadFile(pPram->hSourceFile,pBuffer,CFP_BUFFER_SIZE,&dwRead,NULL);

		if(dwRemaining > dwRead)
		{
			WriteFile(pPram->hOutputFile,pBuffer,dwRead,&dwWrite,0);
			dwRemaining -=dwRead;
		}
		else if (dwRead >= dwRemaining)
		{
			WriteFile(pPram->hOutputFile,pBuffer,dwRemaining,&dwWrite,0);
			dwRemaining=0;
		}

		dwWritten+=dwWrite;// add written bytes. 
		// get percentage and set progress bar position.
		SendMessage(hPb,PBM_SETPOS,GetPercent(dwWritten,pPram->dwLength),0);


	} while (dwRead > 0 && dwRemaining > 0 && bSuccess && g_bCancel==FALSE);

	EndDialog(pPram->hwnd,0);// close copying dialog at finish.
}

// get percentage from DWORD values and return as signed integer(int).
// todo:: improve this function.
int GetPercent(DWORD dwNewValue,DWORD dwMax)
{
	double dMax,dNewValue,dRet;
	int iRet;

	dMax=dwMax;
	dNewValue=dwNewValue;

	dRet =dNewValue / dMax;
	dRet *=100;

	iRet=dRet; // ???

	return(iRet);
}
