#pragma once

#include <Windows.h> 
#include <shlwapi.h> //Path related function  
#include <commctrl.h> //Progress bar messages and InitCommonControls function 
#include "resource.h" 

//Cfp used in CopyFilePartEx.
typedef struct Cfp
{
	HWND hwnd;
	HANDLE hSourceFile;
	HANDLE hOutputFile;
	LONG lStartByte;
	DWORD dwLength;
}CfpEx;

// buffer size for reading and writing to files.
#define CFP_BUFFER_SIZE 4096
// buffer size for path related functions and getting text from text boxes.
#define BUF_SIZE MAX_PATH

//Keep size small of executable by dynamic linkage of C run-time library 
//Caution : using "MSVCRT.LIB" program will need MSVCRT.DLL(vc++6) or MSVCP71.DLL(vc++2003) to run.
//#pragma comment(linker, "/nodefaultlib:libc.lib")//Disable C run-time library static linkage.
//#pragma comment(linker, "/defaultlib:MSVCRT.LIB")//Link dynamic C run-time library {msvcrt.dll). 

//Disable fast load future for Window 98 and program size will get smaller( VC++6 only).
//#pragma comment(linker, "/OPT:NOWIN98")

#pragma comment( lib, "shlwapi.lib" )//SHLWAPI.DLL
#pragma comment( lib, "comctl32.lib" )//COMCTL32.DLL

LRESULT CALLBACK DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CopyingDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Copy(HWND hWndDlg); 
BOOL CopyFilePart(HWND hWnd,LPSTR lpSourceFileName,LPSTR lpOutputFileName,LONG lStartByte,DWORD dwLength);
void CopyPart(HANDLE hfSource,HANDLE hfOutput,LONG lStartByte,DWORD dwLength);
void CopyPartEx(CfpEx * pPram);
void GetFilePath(HWND hwnd,HWND hTextBox,BOOL bOpen);
DWORD GetFileSize(LPSTR szFilePath);
void ErrMsg(HWND hwnd,LPSTR lpMsg);
int GetPercent(DWORD dwNewValue,DWORD dwMax);



